package me.teridax.jcash.gui.takeoff;

import me.teridax.jcash.Logging;
import me.teridax.jcash.Main;
import me.teridax.jcash.banking.accounts.Account;

import static javax.swing.JOptionPane.ERROR_MESSAGE;
import static javax.swing.JOptionPane.showMessageDialog;
import static me.teridax.jcash.lang.Translator.translate;

public class TakeoffDialog {

    private final Account account;
    private final Runnable onTakeoff;
    private final TakeoffView view;

    public TakeoffDialog(Account account, Runnable onTakeoff) {
        this.account = account;
        this.onTakeoff = onTakeoff;

        this.view = new TakeoffView();

        this.view.getTakeoff().addActionListener(e -> takeOff());
        this.view.getCancel().addActionListener(e -> view.dispose());
        this.view.showDialog();
    }

    private void takeOff() {
        try {
            account.takeoff(view.getAmount());
            onTakeoff.run();
            view.dispose();
        } catch (IllegalArgumentException ex) {
            Logging.LOGGER.severe("Could not take off money: " + ex.getMessage());
            showMessageDialog(Main.getInstance().getWindow(), "Reason: " + ex.getMessage(), translate("Could not take off money"), ERROR_MESSAGE);
        }
    }
}
